# Starting code for Lab 12

from graphics import *
import random, time

class Ball(Circle):  # Ball class inherits from Circle class

    # constructor
    def __init__(self, win, center, radius, color):
        super().__init__(center, radius)  # call the Circle constructor
        self.setFill(color)
        self.setOutline(color)
        self.draw(win)
        self.win = win  # so we can refer to the window later
        # have the ball move faster horizontally than vertically
        self.dx = random.uniform(3, 4)
        self.dy = random.uniform(2, 3)
        # randomly determine whether the ball starts moving up or down
        if random.choice(['up', 'down']) == 'up':
            self.dy = -1 * self.dy


def balltest():
    win = GraphWin("Bouncing Balls", 500, 500)
    redBall = Ball(win, Point(100,120), 15, "red")
    blueBall = Ball(win, Point(250,250), 15, "blue")
    greenBall = Ball(win, Point(400,300), 15, "green")
    print("red ball center is", redBall.getCenter())
    print("red ball radius is", redBall.getRadius())

#--------------------------------------------------------------------------

class Pong:

    # constructor
    def __init__(self):
        self.win = GraphWin("Pong!", 400, 300)
        self.win.setBackground("light gray")
        self.paddle = Rectangle(Point(370,100), Point(380,150))
        self.paddle.setFill("black")
        self.paddle.draw(self.win)
        start = Point(random.randrange(25, 100), random.randrange(50, 250))
        self.ball = Ball(self.win, start, 15, "red")

    def play(self):
        print("Click the mouse to begin the game, and good luck.")
        self.win.getMouse()  # wait for a mouse click to begin


def main():
    print("Welcome to single-player Pong!")
    print("The ball will move faster the longer you last.")
    game = Pong()
    game.play()
